<template>
	<p class="text-center text-lg font-bold mt-2">Scan Here!</p>
	<video
		:srcObject="vidSrcObj"
		@pause="updateElement"
		@play="updateElement"
		@canplay="updateElement"
		autoplay="true"
		class="border-8 rounded-md h-72 bg-black border-black mx-auto"
	></video>
	<div class="mt-8 mb-8">
		<p class="text-red-500">{{ warningMessage }}</p>
		<div v-show="paused">
			<button class="py-2 px-8 bg-green-400 rounded-lg" @click="play">
				Scan Again
			</button>
		</div>
	</div>
	<Result :result="result" />
</template>

<script>
import { ref, computed } from "@vue/reactivity";
import { getData } from "../utils/function";
import { useStore } from "vuex";
import { onMounted } from "@vue/runtime-core";
import { SET_RESULT_VID, SET_WARNING_MESSAGE_VID } from "../store/mutations";

import Result from "../components/Result.vue";

export default {
	name: "QRCode",
	components: {
		Result
	},
	setup() {
		const store = useStore();

		const videoElement = ref(null);
		const vidSrcObj = ref(null);
		const paused = ref(false);

		const result = computed(() => store.state.result.fromVideo.result);
		const warningMessage = computed(() => store.state.result.fromVideo.warningMessage);

		const updateElement = (e) => {
			videoElement.value = e.target;
		};

		const decodeVideo = () => {
			getData(null, (error, result) => {
				if (error) {
					store.commit(SET_WARNING_MESSAGE_VID, error)
				} else {
					store.commit(SET_RESULT_VID, result)
				}
				pause();
			});
		};

		const pause = () => {
			videoElement.value.pause();
			paused.value = true;
		};

		const play = () => {
			store.commit(SET_WARNING_MESSAGE_VID, null);
			store.commit(SET_RESULT_VID, null)
			paused.value = false;

			videoElement.value.play();
			decodeVideo();
		};

		const configureVideo = () => {
			if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
				const constraint = { video: true, audio: false };

				navigator.mediaDevices
					.getUserMedia(constraint)
					.then((stream) => {
						vidSrcObj.value = stream;
					});
			} else {
				this.warningMessage = "Sorry, not supported for your browser.";
			}
		};

		onMounted(() => {
			store.commit(SET_WARNING_MESSAGE_VID, null);
			store.commit(SET_RESULT_VID, null)
			configureVideo();
			decodeVideo();
		});

		return {
			videoElement,
			vidSrcObj,
			paused,
			result,
			warningMessage,
			updateElement,
			play,
		};
	},
};
</script>

<style>
</style>